/*
 * Copyright (c) 1995, the EUROPAGATE consortium (see below).
 *
 * The EUROPAGATE consortium members are:
 *
 *    University College Dublin
 *    Danmarks Teknologiske Videnscenter
 *    An Chomhairle Leabharlanna
 *    Consejo Superior de Investigaciones Cientificas
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation, in whole or in part, for any purpose, is hereby granted,
 * provided that:
 *
 * 1. This copyright and permission notice appear in all copies of the
 * software and its documentation. Notices of copyright or attribution
 * which appear at the beginning of any file must remain unchanged.
 *
 * 2. The names of EUROPAGATE or the project partners may not be used to
 * endorse or promote products derived from this software without specific
 * prior written permission.
 *
 * 3. Users of this software (implementors and gateway operators) agree to
 * inform the EUROPAGATE consortium of their use of the software. This
 * information will be used to evaluate the EUROPAGATE project and the
 * software, and to plan further developments. The consortium may use
 * the information in later publications.
 * 
 * 4. Users of this software agree to make their best efforts, when
 * documenting their use of the software, to acknowledge the EUROPAGATE
 * consortium, and the role played by the software in their work.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED, OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 * IN NO EVENT SHALL THE EUROPAGATE CONSORTIUM OR ITS MEMBERS BE LIABLE
 * FOR ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF
 * ANY KIND, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND
 * ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * $Log: winterp.h,v $
 * Revision 1.4  1995/11/06 17:44:22  adam
 * State reestablised when shell restarts. History of previous
 * result sets.
 *
 * Revision 1.3  1995/10/27  15:12:07  adam
 * IrTcl incorporated in the gateway.
 * Better separation of script types.
 * Z39.50 gateway scripts entered.
 *
 * Revision 1.2  1995/10/23  16:55:39  adam
 * A lot of changes - really.
 *
 * Revision 1.1  1995/10/20  14:02:42  adam
 * First version of WWW gateway with embedded Tcl.
 *
 */

#ifndef WINTERP_H
#define WINTERP_H

#include "wproto.h"

typedef struct w_interp_type {
    char  *name;
    void  *(*create)(WCLIENT wcl, void *args);
    int   (*exec)(const char *fname, char *parms, void *private);
    int   (*load_state)(char *parms, void *private);
    int   (*save_state)(char *parms, void *private);
} *W_Interp_Type;

typedef struct w_interp {
    void         *mydata;
    W_Interp_Type ctrl;
} *W_Interp;
    
W_Interp w_interp_create (W_Interp_Type type, WCLIENT wcl, void *args);
#define w_interp_exec(w,f,p) (*(w)->ctrl->exec)((f),(p), (w)->mydata)
#define w_interp_load_state(w,p) (*(w)->ctrl->save_state)((p), (w)->mydata)
#define w_interp_save_state(w,p) (*(w)->ctrl->load_state)((p), (w)->mydata)
#define w_interp_name(w) ((w)->ctrl.name)

#endif
